<template>
  <div id="app">
    <div class="notifications">
      <ToastMessage v-for="(error, key) in errors" :key="key" :type="'error'" :message="error" />
    </div>
    <nav>
      <div class="tab-container">
        <div class="content">
          <ul>
            <li :class="(selectedTab == 'view')?'selected':''" @click="selectedTab = 'view'">
              <a>View</a>
            </li>
            <li :class="(selectedTab == 'edit')?'selected':''" @click="selectedTab = 'edit'">
              <a>Edit</a>
            </li>
          </ul>
        </div>
      </div>
    </nav>
    <section v-if="selectedTab == 'view'" class="section-view">
      <div class="content">
        <json-renderer v-bind:json="json" />
      </div>
    </section>
    <section v-if="selectedTab == 'edit'" class="section-edit">
      <div class="content">
        <json-input
          :initJsonStr="initJsonStr"
          @updateJson="json = $event"
          @triggerError="errors.push($event)"
        />
      </div>
    </section>
  </div>
</template>

<script>
import "cirrus-ui";

import JsonInput from "./components/JsonInput.vue";
import JsonRenderer from "./components/JsonRenderer.vue";
import ToastMessage from "./components/ToastMessage.vue";

export default {
  name: "app",
  components: {
    JsonInput: JsonInput,
    JsonRenderer: JsonRenderer,
    ToastMessage: ToastMessage,
  },
  data() {
    return {
      selectedTab: "edit",
      json: {},
      errors: [],
      initJsonStr:
        '{"glossary": {"title": "example glossary","GlossDiv": {"title": "S","GlossList": {"GlossEntry": {"ID": "SGML","SortAs": "SGML","GlossTerm": "Standard Generalized Markup Language","Acronym": "SGML","Abbrev": "ISO 8879:1986","GlossDef": {    "para": "A meta-markup language, used to create markup languages such as DocBook.",  "GlossSeeAlso": ["GML", "XML"]},"GlossSee": "markup"}}}}}',
    };
  },
};
</script>

<style lang="css">
body {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  font-size: 16px;
}

.content {
  max-width: 1080px;
}

.notifications {
  position: fixed;
  right: 1rem;
}
</style>
